int i=0;
const int pulsepin = 3;
int ledState;
unsigned long previousMicros=0;
unsigned long previousMillis=0;

int lookup[64] = {1,2,4,6,9,12,16,20,25,30,36,
42,49,56,64,72,81,90,100,110,121,132,
144,156,169,182,196,210,225,240,256,272,289,
306,324,342,361,380,400,420,441,462,484,506,
529,552,576,600,625,650,676,702,729,756,784,
812,841,870,900,930,961,992,992,992};

unsigned long lampOnMinutes = 60;        //length of time the lamp will be on since sunrise ended
unsigned long lampOnMilliSeconds = (lampOnMinutes*60*1000);

int duty;                       //high time in microseconds
long sunriseMin = 30;           //length of sunrise in minutes
long stepMillis = sunriseMin*60*1000/64;

long pulsePeriodMicros = 5000; //pulse period in microseconds

void setup()
{
  pinMode(pulsepin, OUTPUT);
//  Serial.begin(9600);
}

void loop()
{  
  //
  //
  //
  //insert code here
  //
  //
  unsigned long currentMicros = micros();
  unsigned long currentMillis = millis();
  duty = lookup[i]*5;

   if (i<64){
    if(currentMicros - previousMicros >pulsePeriodMicros){
      previousMicros=currentMicros;
    }
    if(currentMicros - previousMicros < duty){
      ledState=HIGH;
    }
    if(currentMicros - previousMicros > duty){
      ledState = LOW;
    }
    if(currentMillis - previousMillis >stepMillis){
      previousMillis = currentMillis;
      i++;
//      Serial.print("i=");
//      Serial.println(i); 
    }
   }
   
   if(i==64){
     if (currentMillis - previousMillis  < lampOnMilliSeconds){
       ledState = HIGH;
//       Serial.print("Time elapsed since sunrise=");
//       Serial.println(currentMillis - previousMillis);
//       delay(10000);
     }
     if (currentMillis - previousMillis > lampOnMilliSeconds){ 
       ledState = LOW;
//       Serial.print(lampOnMinutes)
//       Serial.println(" minutes is up! Lamp is off.");
//       delay(10000);
     }
   }
    digitalWrite(pulsepin, ledState);
}
